package com.sundot.airport.system.service;

import java.util.List;

import com.sundot.airport.common.core.domain.TreeSelect;
import com.sundot.airport.common.core.domain.DeptUserTreeSelect;
import com.sundot.airport.common.core.domain.entity.SysDept;
import com.sundot.airport.common.core.domain.entity.SysUser;
import com.sundot.airport.common.dto.DeptInfo;

/**
 * 部门管理 服务层
 *
 * @author ruoyi
 */
public interface ISysDeptService {
    /**
     * 查询部门管理数据
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDeptList(SysDept dept);

    /**
     * 查询部门树结构信息
     *
     * @param dept 部门信息
     * @return 部门树信息集合
     */
    public List<TreeSelect> selectDeptTreeList(SysDept dept);

    /**
     * 查询部门及用户树结构信息
     *
     * @param dept 部门信息
     * @return 部门及用户树信息集合
     */
    public List<DeptUserTreeSelect> selectDeptUserTreeList(SysDept dept);

    /**
     * 根据角色ID查询部门树信息
     *
     * @param roleId 角色ID
     * @return 选中部门列表
     */
    public List<Long> selectDeptListByRoleId(Long roleId);

    /**
     * 根据部门ID查询信息
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    public SysDept selectDeptById(Long deptId);

    /**
     * 根据ID查询所有子部门（正常状态）
     *
     * @param deptId 部门ID
     * @return 子部门数
     */
    public int selectNormalChildrenDeptById(Long deptId);

    /**
     * 是否存在子节点
     *
     * @param deptId 部门ID
     * @return 结果
     */
    public boolean hasChildByDeptId(Long deptId);

    /**
     * 查询部门是否存在用户
     *
     * @param deptId 部门ID
     * @return 结果 true 存在 false 不存在
     */
    public boolean checkDeptExistUser(Long deptId);

    /**
     * 校验部门名称是否唯一
     *
     * @param dept 部门信息
     * @return 结果
     */
    public boolean checkDeptNameUnique(SysDept dept);

    /**
     * 校验部门是否有数据权限
     *
     * @param deptId 部门id
     */
    public void checkDeptDataScope(Long deptId);

    /**
     * 新增保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    public int insertDept(SysDept dept);

    /**
     * 修改保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    public int updateDept(SysDept dept);

    /**
     * 删除部门管理信息
     *
     * @param deptId 部门ID
     * @return 结果
     */
    public int deleteDeptById(Long deptId);

    /**
     * 查询部们数据，包含所有上级
     *
     * @param deptId 部门信息 id
     * @return 部们信息集合
     */
    public List<SysDept> selectAllDept(Long deptId);

    /**
     * 查询部门负责人
     *
     * @param deptId 部门ID
     * @return 负责人信息
     */
    public SysUser deptLeader(Long deptId);

    /**
     * 获取部门下所有部门信息(包含父部门)
     *
     * @param dept 参数
     * @return 用户信息集合
     */
    public List<SysDept> selectDeptInfo(SysDept dept);

    /**
     * 根据部门ID列表查询信息
     *
     * @param list 部门ID列表
     * @return 部门信息
     */
    public List<SysDept> selectDeptByIdList(List<Long> list);

    /**
     * 查询部门管理数据
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDeptInfoAll(SysDept dept);

    /**
     * 构建前端所需要树结构
     *
     * @param depts 部门列表
     * @return 树结构列表
     */
    public List<SysDept> buildDeptTree(List<SysDept> depts);

    /**
     * 构建前端所需要下拉树结构
     *
     * @param depts 部门列表
     * @return 下拉树结构列表
     */
    public List<TreeSelect> buildDeptTreeSelect(List<SysDept> depts);

    /**
     * 查询部门指定角色人员
     *
     * @param deptId 部门ID
     * @return 指定角色人员
     */
    public List<SysUser> deptRole(Long deptId, List<String> roleKeyList);

    /**
     * 查询指定部门的上级部门信息
     *
     * @param deptId 部门ID
     * @return 上级部门信息
     */
    public DeptInfo getDeptInfoByDeptId(Long deptId);

    /**
     * 根据ID查询所有子部门
     *
     * @param deptId 部门ID
     * @return 部门列表
     */
    public List<SysDept> selectChildrenDeptById(Long deptId);
}